unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, SDL_polchart, StdCtrls, SDL_NumIO, ExtCtrls,
  SDL_NumLab, Menus, System.ComponentModel;

type
  TFrmPolChart = class(TForm)
    PC: TPolChart;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    NLabAngleOffs: TNumLab;
    SBarMag: TScrollBar;
    SBarRangeHigh: TScrollBar;
    NIORayAngle: TNumIO;
    SBarAngleOffs: TScrollBar;
    RGRotDir: TRadioGroup;
    RGUseDeg: TRadioGroup;
    RGAngLabelMode: TRadioGroup;
    Label6: TLabel;
    SBarRangeLow: TScrollBar;
    NLabRad: TNumLab;
    NLabPhi: TNumLab;
    PopupMenu1: TPopupMenu;
    PopMenNoMouseAct: TMenuItem;
    Pan1: TMenuItem;
    Zoom1: TMenuItem;
    DragLabels1: TMenuItem;
    RGCrossHair: TRadioGroup;
    RGRadLabels: TRadioGroup;
    Reset1: TMenuItem;
    RGGridRad: TRadioGroup;
    RGGridAng: TRadioGroup;
    EdUnitsRad: TEdit;
    EdUnitsAng: TEdit;
    procedure SBarMagChange(Sender: TObject);
    procedure SBarRangeHighChange(Sender: TObject);
    procedure NIORayAngleChange(Sender: TObject);
    procedure SBarAngleOffsChange(Sender: TObject);
    procedure RGRotDirClick(Sender: TObject);
    procedure RGUseDegClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RGAngLabelModeClick(Sender: TObject);
    procedure PCZoomPan(Sender: TObject);
    procedure SBarRangeLowChange(Sender: TObject);
    procedure PCMouseMoveInChart(Sender: TObject; InChart: Boolean;
      Shift: TShiftState; rMousePosX, rMousePosY: Double);
    procedure Pan1Click(Sender: TObject);
    procedure PopMenNoMouseActClick(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure DragLabels1Click(Sender: TObject);
    procedure PCBeforeDrawScaleLabel(Sender: TObject; var Canvas: TCanvas;
      ScaleType: TpcScaleKind; var CurrentTickLabel: String; ChartX,
      ChartY: Integer);
    procedure RGCrossHairClick(Sender: TObject);
    procedure RGRadLabelsClick(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure RGGridRadClick(Sender: TObject);
    procedure RGGridAngClick(Sender: TObject);
    procedure EdUnitsChange(Sender: TObject);
  private
    procedure DrawData;
  public
    { Public declarations }
  end;

var
  FrmPolChart: TFrmPolChart;

implementation

{$R *.dfm}

uses
  SDL_sdlbase, SDL_stringl, printers;

(******************************************************************************)
procedure TFrmPolChart.DrawData;
(******************************************************************************)

var
  i : integer;

begin
PC.ClearGraf;
PC.RangeLow := 0;
PC.RangeHigh := 10;
PC.DataColor := clRed;
PC.MoveTo(0,0);
PC.LineWidth := 1;
for i:=1 to 1000 do
  PC.DrawTo (i/100,i/50);
PC.DataColor := clBlue;
PC.TransparentItems := true;
PC.LineWidth := 1;
i := PC.AddTextLabel (6, 210, clBlue, 'This is a text label', 0);
PC.TextLabels[i].AttachToData := true;
PC.TextLabels[i].Mode := tlShadow;
PC.TextLabels[i].ShadowDx := 3;
PC.TextLabels[i].ShadowDy := 6;
PC.ShowGraf;
end;

(******************************************************************************)
procedure TFrmPolChart.SBarMagChange(Sender: TObject);
(******************************************************************************)

begin
PC.MagFactor := SBarMag.Position/100;
end;

(******************************************************************************)
procedure TFrmPolChart.SBarRangeHighChange(Sender: TObject);
(******************************************************************************)

begin
PC.RangeHigh := SBarRangeHigh.Position/10;
end;


(******************************************************************************)
procedure TFrmPolChart.SBarRangeLowChange(Sender: TObject);
(******************************************************************************)

begin
PC.RangeLow := SBarRangeLow.Position/10;
end;


(******************************************************************************)
procedure TFrmPolChart.NIORayAngleChange(Sender: TObject);
(******************************************************************************)

begin
PC.AngleBtwRays := round(NIORayAngle.Value);
end;

(******************************************************************************)
procedure TFrmPolChart.SBarAngleOffsChange(Sender: TObject);
(******************************************************************************)

begin
if PC.UseDegrees
  then PC.AngleOffset := SBarAngleOffs.Position
  else PC.AngleOffset := SBarAngleOffs.Position/180*pi;
NLabAngleOffs.Value := PC.AngleOffset;
end;

(******************************************************************************)
procedure TFrmPolChart.RGRotDirClick(Sender: TObject);
(******************************************************************************)

begin
if RGRotDir.ItemIndex = 0
  then PC.RotationDir := rdClockwise
  else PC.RotationDir := rdCounterCW;
end;

(******************************************************************************)
procedure TFrmPolChart.RGUseDegClick(Sender: TObject);
(******************************************************************************)

begin
PC.UseDegrees := (RGUseDeg.ItemIndex = 0);
if PC.UseDegrees
  then begin
       NLabANgleOffs.Precision := 0;
       NLabANgleOffs.RightText := 'deg';
       PC.AngleOffset := SBarAngleOffs.Position;
       PC.LabelModeAngular := almDegrees;
       RGAngLabelMode.ItemIndex := ord(almDegrees);
       end
  else begin
       NLabANgleOffs.Precision := 2;
       NLabANgleOffs.RightText := 'rad';
       PC.AngleOffset := SBarAngleOffs.Position/180*Pi;
       PC.LabelModeAngular := almRadians;
       RGAngLabelMode.ItemIndex := ord(almRadians);
       end;
NLabANgleOffs.Value := PC.AngleOffset; 
end;

(******************************************************************************)
procedure TFrmPolChart.FormShow(Sender: TObject);
(******************************************************************************)

begin
DrawData;
end;

(******************************************************************************)
procedure TFrmPolChart.RGAngLabelModeClick(Sender: TObject);
(******************************************************************************)

begin
PC.LabelModeAngular := TpcAngLabelMode (RGAngLabelMode.ItemIndex);
end;

(******************************************************************************)
procedure TFrmPolChart.PCZoomPan(Sender: TObject);
(******************************************************************************)

begin
SBarMag.Position := round(PC.MagFactor*100);
end;


(******************************************************************************)
procedure TFrmPolChart.PCMouseMoveInChart(Sender: TObject; InChart: Boolean;
  Shift: TShiftState; rMousePosX, rMousePosY: Double);
(******************************************************************************)

begin
NLabRad.Value := rMousePosX;
NLabPhi.Value := rMousePosY;
if RGCrossHair.ItemIndex > 0 then
  PC.CrossHair1.SetPosition (rMousePosX, rMousePosY);
end;

(******************************************************************************)
procedure TFrmPolChart.Pan1Click(Sender: TObject);
(******************************************************************************)

begin
PC.MouseAction := maPan;
end;

(******************************************************************************)
procedure TFrmPolChart.PopMenNoMouseActClick(Sender: TObject);
(******************************************************************************)

begin
PC.MouseAction := maNone;
end;

(******************************************************************************)
procedure TFrmPolChart.Zoom1Click(Sender: TObject);
(******************************************************************************)

begin
PC.MouseAction := maZoomDrag;
end;

(******************************************************************************)
procedure TFrmPolChart.DragLabels1Click(Sender: TObject);
(******************************************************************************)

begin
PC.MouseAction := maDragLabel;
end;


(******************************************************************************)
procedure TFrmPolChart.PCBeforeDrawScaleLabel(Sender: TObject;
  var Canvas: TCanvas; ScaleType: TpcScaleKind; var CurrentTickLabel: String;
  ChartX, ChartY: Integer);
(******************************************************************************)

begin
if ScaleType = sckRad
  then CurrentTickLabel := CurrentTickLabel + EdUnitsRad.Text
  else CurrentTickLabel := CurrentTickLabel + EdUnitsAng.Text;
end;


(******************************************************************************)
procedure TFrmPolChart.RGCrossHairClick(Sender: TObject);
(******************************************************************************)

begin
PC.CrossHair1.Mode := TpcCrossHMode(RGCrossHair.ItemIndex);
end;

(******************************************************************************)
procedure TFrmPolChart.RGRadLabelsClick(Sender: TObject);
(******************************************************************************)

begin
PC.LabelModeRadial := TpcRadLabelMode (RGRadLabels.ItemINdex);
end;

(******************************************************************************)
procedure TFrmPolChart.Reset1Click(Sender: TObject);
(******************************************************************************)

begin
PC.UseDegrees := true;
NLabANgleOffs.Precision := 0;
NLabANgleOffs.RightText := 'deg';
PC.AngleOffset := SBarAngleOffs.Position;
PC.LabelModeAngular := almDegrees;
RGAngLabelMode.ItemIndex := ord(almDegrees);
NLabANgleOffs.Value := PC.AngleOffset;
PC.MagFactor := 0.7;
PC.AngleOffset := 0;
PC.AngleBtwRays := 30;
PC.RangeLow := 0;
PC.RangeHigh := 10;
PC.CenterChart;
end;

(******************************************************************************)
procedure TFrmPolChart.RGGridRadClick(Sender: TObject);
(******************************************************************************)

begin
PC.GridStyleRadial := TpcGridStyleRad(RGGridRad.Itemindex);
end;

(******************************************************************************)
procedure TFrmPolChart.RGGridAngClick(Sender: TObject);
(******************************************************************************)

begin
PC.GridStyleAngular := TpcGridStyleAng(RGGridAng.Itemindex);
end;

(******************************************************************************)
procedure TFrmPolChart.EdUnitsChange(Sender: TObject);
(******************************************************************************)

begin
PC.ShowGraf;
end;


end.
